/*
 * ##################################################
 * #                                                #
 * # rkNumberConverter                              #
 * # Number system conversation                     #
 * #                                                #
 * # Copyright (C) by René Knipschild               #
 * #                                                #
 * #                                email@rkcsd.com #
 * #                         www.reneknipschild.net #
 * #                                                #
 * ##################################################
 *
 * File: NumberConverter.java -tools
 * Version: 1.0.0
 * Last modified: 2011/04/20 09:40 CEST
 * Author: rkCSD (go.reneknipschild.net/com)
 *
 * ===Notes==========================================
 * There are currently no notes.
 * ==================================================
 */

package com.rkcsd.apps.desktoptools.numberconverter.tools;

public class NumberConverter {
	public static final String[] NUMBERSYSTEMS = { "BIN", "OCT", "DEC", "HEX" };

	public static final String[] NUMBERSYSTEMS_MATCH = { "[01]*", "[0-7]*", "[0-9]*", "[0-9a-fA-F]*" };
	
	public static String convert(String value, int from, int to) {
		int dec = 0;
		if (from == 0) {
			int n = -1;
			for (int i = value.length(); i > 0; i--) {
				n++;
				if (value.charAt(i - 1) == '1') {
					dec += Math.pow(2, n);
				}
			}
		} else if (from == 1) {
			int n = -1;
			for (int i = value.length(); i > 0; i--) {
				n++;
				int x = Integer.parseInt(String.valueOf(value.charAt(i - 1)));
				dec += x * Math.pow(8, n);
			}
		} else if (from == 2) {
			dec = Integer.parseInt(value);
		} else if (from == 3) {
			int n = -1;
			for (int i = value.length(); i > 0; i--) {
				n++;
				String x = String.valueOf(value.charAt(i - 1));
				if (x.matches(NumberConverter.NUMBERSYSTEMS_MATCH[3])) {
					x = x.replace("a", "10");
					x = x.replace("A", "10");
					x = x.replace("b", "11");
					x = x.replace("B", "11");
					x = x.replace("c", "12");
					x = x.replace("C", "12");
					x = x.replace("d", "13");
					x = x.replace("D", "13");
					x = x.replace("e", "14");
					x = x.replace("E", "14");
					x = x.replace("f", "15");
					x = x.replace("F", "15");
				}
				int y = Integer.parseInt(x);
				dec += y * Math.pow(16, n);
			}
		}
		String result = "";
		if (to == 0) {
			double dec_exact = dec;
			int dec_rounded = dec;
			while (dec_rounded > 0) {
				dec_exact = (double) dec_rounded / 2;
				dec_rounded = (int) dec_exact;
				if (dec_exact != dec_rounded) {
					result = "1" + result;
				} else {
					result = "0" + result;
				}
			}
		} else if (to == 1) {
			double dec_exact = dec;
			int dec_rounded = dec;
			double rest = 0;
			while (dec_rounded > 0) {
				dec_exact = (double) dec_rounded / 8;
				dec_rounded = (int) dec_exact;
				rest = (dec_exact - dec_rounded) * 8;
				result = String.valueOf((int) rest) + result;
			}
		} else if (to == 2) {
			result = String.valueOf(dec);
		} else if (to == 3) {
			double dec_exact = dec;
			int dec_rounded = dec;
			double rest = 0;
			while (dec_rounded > 0) {
				dec_exact = (double) dec_rounded / 16;
				dec_rounded = (int) dec_exact;
				rest = (dec_exact - dec_rounded) * 16;
				String add = String.valueOf((int) rest);
				add = add.replace("10", "A");
				add = add.replace("11", "B");
				add = add.replace("12", "C");
				add = add.replace("13", "D");
				add = add.replace("14", "E");
				add = add.replace("15", "F");
				result = add + result;
			}
		}
		return result;
	}
}